﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Console; //Static using
using System.IO;

namespace WhatsNewCS
{
    class Program
    {
        static void Main(string[] args)
        {
            Person1 p = new Person1("Alessandro", "Del Sole");
        }

        private void ExceptionFilters()
        {
            try
            {
                throw new Exception("Alessandro");
            }
            catch (Exception ex) if (ex.Message == "Daniele")
            {
                // Non viene considerata
            }
            catch (Exception ex) if (ex.Message == "Alessandro")
            {
                // Viene considerata
            }
        }

        private void staticUsing()
        {
            WriteLine("Ciao Roma!");
            ReadLine();
        }

        private void declarationExpressions()
        {
            // Vecchia sintassi
            //long id;
            //if (!long.TryParse("100", out id))
            //{
            //    // Fai qualcosa
            //}

            // Nuova possibilità
            if (!long.TryParse("100", out long id))
            { }

            // ammesso anche....
            if (!long.TryParse("100", out var id))
            { }

        }

        private Double nullCheck()
        {
            var points = new List<Point>();

            // vecchia modalità
            if (points != null)
            {
                var next = points.FirstOrDefault();
                if (next != null && next.x != null) return next.x.Value;
            }
            return -1;

            // nuova modalità: rimuove la necessità di controllare se
            // l'oggetto è null prima di accedere a proprietà o metodo
            var bestValue = points?.FirstOrDefault()?.x ?? -1;
        }

        private async void awaitInCatchFinally()
        {
            FileStream str = new FileStream("C:\\temp\\miofile.txt", FileMode.Open); 
            try
            {
                byte[] bytes=new byte[100];
                var content = await str.ReadAsync(bytes,0,1024);
                
            }
            catch (Exception)
            {
                // ....
            }
            finally
            {
                await str.FlushAsync();
            }
        }

        // ****** ATTENZIONE: NON ANCORA DISPONIBILE NELLA CTP ATTUALE ******
        private void dictionaryInitializers()
        {
            // vecchia modalità
            var oldWay = new Dictionary<string, int>()
            {
                { "A", 1 },
                { "B", 2 },
                { "C", 3 }
            };

        // nuove modalità
        var newWay = new Dictionary<string, int>()
            {
                ["A"] = 1,
                ["B"] = 2,
                ["C"] = 3
            };

        var newWay1 = new Dictionary<string, int>()
        {
                $A = 1,
                $B = 2,
                $C = 3
        };

        int a = newWay1.$A
        // *****************************************************************
    }

}

    //Auto property initializer
    class Person
    {
        string FirstName { get; set; } = "Alessandro";
        string LastName { get; } = "Del Sole";
    }

    // Primary constructor
    class Person1(string firstName, string lastName)
    {
        string FirstName { get; set; } = firstName;
        string LastName { get; } = lastName;
    }
}
